#!/bin/bash

#dynamic

echo " - Compiling and running dinamically-linked application ..."
gcc -fPIC -shared library.c -o library.so
gcc -L. -lrary application.c -o application
LD_LIBRARY_PATH=.:${LD_LIBRARY_PATH} ./application

# static

echo " - Compiling and running statically-linked application ..."
gcc -c library.c -o library.o
ar rc library.a library.o
ranlib library.a
gcc application.c library.a -o application-static
./application-static

# full static

echo " - Compiling and running full statically-linked application ..."
gcc application.c -L. -lrary -static -o application-static-full
./application-static-full

# clean

echo " - Cleaning up ..."
rm application application-static application-static-full library.a library.so library.o

