
#include <stdio.h>
#include <dlfcn.h>

#include "application.h"

int function(void)
{
	printf("function\n");
	return 0;
}

int main(int argc, const char *argv[])
{
	printf("main\n");
	function();
	
	/* init basic names */
	char *lib = "./library.so";
	char *fcn = "libfunction";
	/* open library and get pointer to it */
	void *ptr = dlopen(lib, RTLD_LAZY);
	if (!ptr) {
		printf("Cannot open library %s (%s)\n", lib, dlerror());
		return -1;
	}
	/* clean up dlerror */
	dlerror();
	typedef void (*lib_t)();
	/* get symbol name for function in library */
	lib_t libfcn = (lib_t) dlsym(ptr, fcn);
	/* check that symbol is really exist */
	const char *dlsym_error = dlerror();
	if (dlsym_error) {
		printf("Cannot load symbol \"%s\" (%s)\n", fcn, dlerror());
		dlclose(ptr);
		return -1;
	}
	/* call function from library */
	libfcn();
	/* close opened library */
	dlclose(ptr);
	/* exit */
	printf("exit\n");
	
	return 0;
}

