#!/bin/bash

echo " Compiling library code to object file and creating libtool file ..."
libtool --mode=compile gcc -c library.c

echo " Generating libraries based on libtool file ..."
libtool --mode=link gcc -rpath /usr/lib -version-info 0:0:0 -o library.la library.lo

echo " Creating static binary executable file ..."
libtool --mode=link gcc library.lo application.c -o application-lo

echo " Creating shared binary executable file ..."
libtool --mode=link gcc library.la application.c -o application-la

echo " Creating shared (-shared) binary executable file ..."
libtool --mode=link gcc -shared library.la application.c -o application-la-shared

echo " Cleaning up ..."
rm -rf application-* application *.la *.lo *.o .libs

