#!/usr/bin/make -f

PROJECT=application

all: clean autotools configure make # dist # clean

autotools:
	@echo " ---- ---- "
	@echo " - Generating autotools build files ..."
	aclocal
	autoconf
	autoheader
	automake -a
	@echo " ---- ---- "

configure:
	@echo " ---- ---- "
	@echo " - Running configuration ..."
	./configure
	@echo " ---- ---- "

make:
	@echo " ---- ---- "
	@echo " - Making project ..."
	make
	@echo " ---- ---- "

dist:
	@echo " ---- ---- "
	@echo " - Creating tarballs ..."
	make dist
	@echo " ---- ---- "

clean:
	@echo " ---- ---- "
	@echo " - Cleaning up generated files ..."
	-rm -rf autom4te.cache aclocal.m4
	-rm -f config.log config.status configure
	-rm -f depcomp INSTALL install-sh Makefile Makefile.in missing
	-rm -f *.tar.*
	-rm -f src/config.h src/config.h.in src/config.h.in~
	-rm -f src/$(PROJECT) src/$(PROJECT).o
	-rm -rf src/Makefile src/Makefile.in src/stamp-h1 src/.deps
	@echo " ---- ---- "

.PHONY: configure
