#!/usr/bin/make -f

PROJECT=application

APPNAME=application
LIBNAME=library

all: clean autotools configure make # dist # clean

autotools:
	@echo " ---- ---- "
	@echo " - Generating autotools build files ..."
	aclocal
	libtoolize
	autoconf
	autoheader
	automake -a
	@echo " ---- ---- "

configure:
	@echo " ---- ---- "
	@echo " - Running configuration ..."
	./configure
	@echo " ---- ---- "

make:
	@echo " ---- ---- "
	@echo " - Making project ..."
	make
	@echo " ---- ---- "

dist:
	@echo " ---- ---- "
	@echo " - Creating tarballs ..."
	make dist
	@echo " ---- ---- "

clean:
	@echo " ---- ---- "
	@echo " - Cleaning up generated files ..."
	-rm -rf autom4te.cache aclocal.m4
	-rm -f config.log config.status config.guess config.sub configure
	-rm -f depcomp INSTALL install-sh Makefile Makefile.in missing *.tar.*
	-rm -f src/config.h src/config.h.in src/config.h.in~
	-rm -f src/$(APPNAME) src/$(APPNAME).o src/$(APPNAME)-$(APPNAME).o
	-rm -rf src/Makefile src/Makefile.in src/stamp-h1 src/.deps
	-rm -rf lib/.deps lib/$(LIBNAME).la lib/$(LIBNAME).lo lib/.libs lib/Makefile lib/Makefile.in
	-rm -rf libtool ltmain.sh m4/* src/.libs lib/stamp-h1 lib/$(LIBNAME)_la-$(LIBNAME).lo
	-rm -rf lib/config.h lib/config.h.in lib/config.h.in~ lib/stamp-h2
	@echo " ---- ---- "

.PHONY: configure

