
#include <stdio.h>        /*  printf()                         */
#include <unistd.h>       /*  getuid() write() close()         */
#include <fcntl.h>        /*  open() flags                     */
#include <sys/ioctl.h>    /*  ioctl()                          */
#include <linux/hdreg.h>  /*  ioctl() flag: HDIO_GET_IDENTITY  */

#define NAME "identification-simple"

int usage(void)
{
	printf("%s - dump identification block from block device to output file \"indentity.bin\"\n", NAME);
	printf("  Note : root access required\n");
	printf("  Usage:\n\t%s /path/to/block/device\n", NAME);
	return -1;
}

int main(int argc, const char *argv[])
{
	if ((argc != 2) || (getuid() != 0)) {
		return usage();
	}
	
	char *file = argv[1];
	
	/* open device for ioctl() */
	int blkd = open(file, O_RDONLY);
	
	unsigned char identity[512];
	
	/* get information via ioctl() */
	ioctl(blkd, HDIO_GET_IDENTITY, identity);
	
	/* close block device file */
	close(blkd);
	
	char *ofile = "identity.bin";
	
	/* open file for saving information */
	int output = open(ofile, O_CREAT | O_WRONLY | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
	
	/* write information in file */
	write(output, identity, 512);
	
	/* close file */
	close(output);
	
	return 0;
}

