
//#define _LARGEFILE64_SOURCE

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <linux/hdreg.h>
#include <linux/types.h>
#include <errno.h>

#include <arpa/inet.h>

int endian_swap(unsigned short x)
{
    return (x>>8) | (x<<8);
}

typedef struct slots_s {
	__u8    aflag;
	__u8    chs_b [  3];
	__u8    type;
	__u8    chs_e [  3];
	__u32   lba;
	__u32   size;
} __attribute__ ((packed)) slots_t;

typedef struct partitions_s {
	__u8    boot  [446];
	slots_t slot[4];
	__u16   sign;
} __attribute__ ((packed)) partitions_t;

typedef struct parts_l {
	__u8 n;
	__u8 id;
	__u32 location;
	__u32 lba;
}  __attribute__ ((packed)) parts_id;

parts_id p_id_list[256];

int tmp(partitions_t *partitions, int blkd) {


		printf("\nPartitions types:\n");
		printf("\tslot 1 : %.2hhX\n", partitions->slot[0].type);
		printf("\t\tlba  : %d\n", partitions->slot[0].lba);
		printf("\t\tsize : %d\n", partitions->slot[0].size);
		printf("\tslot 2 : %.2hhX\n", partitions->slot[1].type);
		printf("\t\tlba  : %d\n", partitions->slot[1].lba);
		printf("\t\tsize : %d\n", partitions->slot[1].size);
		printf("\tslot 3 : %.2hhX\n", partitions->slot[2].type);
		printf("\t\tlba  : %d\n", partitions->slot[2].lba);
		printf("\t\tsize : %d\n", partitions->slot[2].size);
		printf("\tslot 4 : %.2hhX\n", partitions->slot[3].type);
		printf("\t\tlba  : %d\n", partitions->slot[3].lba);
		printf("\t\tsize : %d\n", partitions->slot[3].size);

	int i;
	int extnd = -1;
	printf("blkd = %d\n", blkd);
	for (i = 0; i < 4; i++) {
		if (partitions->slot[i].type == 0x05) {
			extnd = i;
			
			if (lseek(blkd, partitions->slot[extnd].lba, SEEK_SET) == -1) {
				printf("lseek: %s\n", strerror(errno));
			}
			if (read(blkd, partitions, 512) != 512) {
				printf("read: %s\n", strerror(errno));
			}
			tmp(partitions, blkd);
		}
		if ( partitions->slot[i].type != 0x00 ) {
			p_id_list->n = i;
			p_id_list->id = partitions->slot[i].type;
			p_id_list->location = 0x1C2 + i*0x10;
			p_id_list->lba = partitions->slot[i].lba;
			printf("%d : %hX : %d : %d\n", p_id_list->n, p_id_list->id, p_id_list->location, p_id_list->lba);
		}

		printf("1\n");
	}
	
	if (extnd > 0) {
		printf("seeking : %d %d\n", extnd, partitions->slot[extnd].lba);
		if (lseek(blkd, partitions->slot[extnd].lba, SEEK_SET) == -1) {
			printf("lseek: %s\n", strerror(errno));
		}
		if (read(blkd, partitions, 512) != 512) {
			printf("read: %s\n", strerror(errno));
		}
		//int f = open("dump", O_CREAT|O_TRUNC|O_WRONLY);
		int f = open("dump", O_CREAT | O_WRONLY | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
		write(f, partitions, 512);
		close(f);
		/*
		printf("\nPartitions types:\n");
		printf("\tslot 1 : %.2hhX\n", partitions->slot[0].type);
		printf("\t\tlba  : %d\n", partitions->slot[0].lba);
		printf("\t\tsize : %d\n", partitions->slot[0].size);
		printf("\tslot 2 : %.2hhX\n", partitions->slot[1].type);
		printf("\t\tlba  : %d\n", partitions->slot[1].lba);
		printf("\t\tsize : %d\n", partitions->slot[1].size);
		printf("\tslot 3 : %.2hhX\n", partitions->slot[2].type);
		printf("\t\tlba  : %d\n", partitions->slot[2].lba);
		printf("\t\tsize : %d\n", partitions->slot[2].size);
		printf("\tslot 4 : %.2hhX\n", partitions->slot[3].type);
		printf("\t\tlba  : %d\n", partitions->slot[3].lba);
		printf("\t\tsize : %d\n", partitions->slot[3].size);
		*/
		//memset(partitions, 0, 512);
		tmp(partitions, blkd);
	}
	return 0;
}

int main(int argc, char const* argv[])
{
	partitions_t *partitions;
	printf("sizeof(partitions_t) = %zd\n", sizeof(partitions_t));
	partitions = malloc(512);
	memset(partitions, 0, 512);
	int blkd = open(argv[1], O_RDONLY | O_LARGEFILE);
	if (blkd == -1) {
		printf("open: %s\n", strerror(errno));
		return -1;
	}
	if (read(blkd, partitions, 512) != 512) {
		printf("read: %s\n", strerror(errno));
		return -1;
	}
	//close(blkd);
	
	printf("\nMBR sign:\n");
	printf("\traw   : %hX\n", partitions->sign);
	printf("\tntohs : %hX\n", ntohs(partitions->sign));
	printf("\tswap  : %hX\n", endian_swap(ntohs(partitions->sign)));
	printf("blkd = %d\n", blkd);
	//close(blkd);
	tmp(partitions, blkd);
	
	/*
	printf("\nPartitions types:\n");
	printf("\tslot 1 : %.2hhX\n", partitions->slot[0].type);
	printf("\t\tlba  : %d\n", partitions->slot[0].lba);
	printf("\t\tsize : %d\n", partitions->slot[0].size);
	*/
	/*
	printf("\tslot 2 : %.2hhX\n", partitions->slot2.type);
	printf("\t\tlba  : %d\n", partitions->slot2.lba);
	printf("\t\tsize : %d\n", partitions->slot2.size);
	printf("\tslot 3 : %.2hhX\n", partitions->slot3.type);
	printf("\t\tlba  : %d\n", partitions->slot3.lba);
	printf("\t\tsize : %d\n", partitions->slot3.size);
	printf("\tslot 4 : %.2hhX\n", partitions->slot4.type);
	printf("\t\tlba  : %d\n", partitions->slot4.lba);
	printf("\t\tsize : %d\n", partitions->slot4.size);
	*/
	free(partitions);
	close(blkd);
	return 0;
}

