
//#define _LARGEFILE64_SOURCE

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <linux/hdreg.h>
#include <linux/types.h>
#include <errno.h>

#include <arpa/inet.h>

int endian_swap(unsigned short x)
{
    return (x>>8) | (x<<8);
}

typedef struct slots_s {
	__u8    aflag;
	__u8    chs_b [  3];
	__u8    type;
	__u8    chs_e [  3];
	__u32   lba;
	__u32   size;
} __attribute__ ((packed)) slots_t;

typedef struct partitions_s {
	__u8    boot  [446];
	slots_t slot[4];
	__u16   sign;
} __attribute__ ((packed)) partitions_t;

typedef struct parts_l {
	__u8 n;
	__u8 id;
	__u32 location;
	__u32 lba;
}  __attribute__ ((packed)) parts_id;

parts_id p_id_list[256];

int main(int argc, char const* argv[])
{
	partitions_t *partitions;
	printf("sizeof(partitions_t) = %zd\n", sizeof(partitions_t));
	partitions = malloc(512);
	memset(partitions, 0, 512);
	int blkd = open(argv[1], O_RDONLY);
	if (blkd == -1) {
		printf("open: %s\n", strerror(errno));
		return -1;
	}
			if (lseek(blkd, 1261723648, SEEK_SET) == -1) {
				printf("lseek: %s\n", strerror(errno));
			}
	if (read(blkd, partitions, 512) != 512) {
		printf("read: %s\n", strerror(errno));
		return -1;
	}
	
	char *ofile = "dump.bin";
	/* open file for saving information */
	int output = open(ofile, O_CREAT | O_WRONLY | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
	/* write information in file */
	write(output, partitions, 512);
	/* close file */
	close(output);
	
	int i = 0, j = 0;
	printf("\nPartitions :\n");
	for (i = 0; i < 4; i++) {
		printf("\tslot %d : %.2hhX\n", i, partitions->slot[i].type);
		printf("\t\tlba  : %d\n", partitions->slot[i].lba);
		printf("\t\tsize : %d\n", partitions->slot[i].size);
	}
	close(blkd);
	
	blkd = open(argv[1], O_RDONLY);
	if (blkd == -1) {
		printf("open: %s\n", strerror(errno));
		return -1;
	}
	
	partitions_t *partitions2;
	//printf("sizeof(partitions_t) = %zd\n", sizeof(partitions_t));
	partitions2 = malloc(512);
	memset(partitions2, 0, 512);
	
	for (i = 0; i < 4; i++) {
		if (partitions->slot[i].type == 0x05) {
			if (lseek(blkd, partitions->slot[i].lba, SEEK_SET) == -1) {
				printf("lseek: %s\n", strerror(errno));
			}
			printf("lseek: %d\n", partitions->slot[i].lba);
			if (read(blkd, partitions2, 512) != 512) {
				printf("read: %s\n", strerror(errno));
			}
			for (j = 0; j < 4; j++) {
				printf("\tslot %d : %.2hhX\n", j, partitions2->slot[j].type);
				printf("\t\tlba  : %d\n", partitions2->slot[j].lba);
				printf("\t\tsize : %d\n", partitions2->slot[j].size);
			}
		}
	}

	free(partitions);
	close(blkd);
	return 0;
}

