
#include <stdio.h>        /*  printf()                         */
#include <unistd.h>       /*  getuid() write() close()         */
#include <fcntl.h>        /*  open() flags                     */

#define NAME "rawblock-simple"

int usage(void)
{
	printf("%s - dump superblock from block device with extN file system to \"superblock.bin\"\n", NAME);
	printf("  Note : root access required\n");
	printf("  Usage:\n\t%s /path/to/block/device/with/extFS\n", NAME);
	return -1;
}

int main(int argc, char const* argv[])
{
	if ((argc != 2) || (getuid() != 0)) {
		return usage();
	}
	
	char *file = argv[1];
	char superblock[1024];
	
	/* open block device for reading */
	int blkd = open(file, O_RDONLY);
	
	/* seek to superblock location */
	lseek(blkd, 1024, SEEK_CUR);
	
	/* read superblock content */
	read(blkd, superblock, 1024);
	
	/* close block file */
	close(blkd);
	
	char *ofile = "superblock.bin";
	
	/* open file for saving information */
	int output = open(ofile, O_CREAT | O_WRONLY | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
	
	/* write information in file */
	write(output, superblock, 1024);
	
	/* close file */
	close(output);
	
	return 0;
}

