#!/bin/bash

module="kernel-module"
version="0.1"
dkms_dir="/usr/src/${module}-${version}"

if [ ! -f dkms.conf ]; then
	echo "No dkms.conf file!"
	exit -1
fi;

echo " ---- ----"
echo " - Preparing source files ..."
echo " ---- ----"
sudo mkdir ${dkms_dir}
sudo cp module.c Makefile dkms.conf ${dkms_dir}/
echo " ---- ----"
echo " - DKMS add ..."
echo " ---- ----"
sudo dkms add -m ${module} -v ${version}
echo " ---- ----"
echo " - DKMS build ..."
echo " ---- ----"
sudo dkms build -m ${module} -v ${version}
echo " ---- ----"
echo " - DKMS install ..."
echo " ---- ----"
sudo dkms install -m ${module} -v ${version}
echo " ---- ----"
echo " - DKMS status and check ..."
echo " ---- ----"
dkms status
modinfo module
sudo modprobe module
echo " ---- ----"
echo " - DKMS pkg, remove and clean ..."
echo " ---- ----"
sudo rmmod module
sudo dkms mkdeb -m kernel-module -v 0.1
sudo dkms remove -m kernel-module -v 0.1 --all
sudo rm -r /usr/src/kernel-module-0.1

